package main

import (
	"fmt"
	"time"

	"gopkg.in/redis.v5"
)

func janitor(redisClient *redis.Client) {
	// loop through the set
	for {
		inprogress, err := redisClient.SMembers("inprogress").Result()
		if err != nil {
			panic(err)
		}
		for _, i := range inprogress {
			// for each user, make sure the expire key exists
			exists, err := redisClient.Exists(fmt.Sprintf("inprogress:%s", i)).Result()
			if err != nil {
				panic(err)
			}
			if !exists {
				redisClient.SRem("inprogress", i)
			}
		}

		time.Sleep(10 * time.Second)
	}
}
